(require 'pd-package)
(in-package predicate-dispatch)

(require 'predicate-classes)
(require 'pc-print)

(defun tp (x)
  (<= x 17))

(defun tq (x)
  (>= x 17))

(defun tr (x)
  (> (sin x) 0))

(defun mkand (&rest l)
  (make-and l))

(defun mkor (&rest l)
  (make-or l))

(defun mknot (p)
  (make-not p))

(defun printnorm (p)
  (format t "Orig: ~:W~%" p)
  (format t "Norm: ~:W~%" (normalize-predicate p)))

(let ((p (make-instance 'test-predicate :test #'tp))
      (q (make-instance 'test-predicate :test #'tq))
      (r (make-instance 'test-predicate :test #'tr)))
  (mapc #'printnorm
	(list (mkor (mkand p q)
		    (mkand p (mknot q))
		    (mkand (mknot p) q)
		    (mkand (mknot p) (mknot q)))
	      (mkor (mkand p q r)
		    (mknot p)
		    (mknot q)
		    (mknot r))
	      (mkor (mkand p q)
		    (mkand (mknot q) r)
		    (mkand (mknot r) (mknot p))
		    (mkand p (mknot q) (mknot r))
		    (mkand (mknot p) q r))
	      )))

(system::quit)

			      
