(require 'predicate-dispatch)
(use-package 'predicate-dispatch)

(require 'pc-print)

;;; adapted from example in Chambers and Chen.

(defclass parent ()
  ((x :reader x :initarg :x)
   (y :reader y :initarg :y)))
(defclass a (parent) ())
(defclass b (a) ())
(defclass c (parent) ())
(defclass d (a c) ())

(defgeneric fun (f1 f2)
  (:generic-function-class gf-with-predicate-dispatching))

(defpdmethod fun ((f1 a) f2)
  ((typep (x f1) 'a)
   (not (typep (x f1) 'b))
   (typep (x f2) 'c)
   (eql (y f1) (y f2)))
  (format t "Method 1!~%")
  (if (next-method-p)
      (call-next-method)))

(defpdmethod fun (f1 f2)
  ((typep (x f1) 'b)
   (or (and (typep f1 'b) (typep (x f2) 'c))
       (and (typep f1 'c) (typep f2 'a))))
  (format t "Method 2!~%")
  (if (next-method-p)
      (call-next-method)))

(defmethod fun ((f1 c) (f2 c))
  (format t "Method 3!~%")
  (if (next-method-p)
      (call-next-method)))

(defmethod fun ((f1 c) f2)
  (format t "Method 4!~%")
  (if (next-method-p)
      (call-next-method)))

(describe 'fun)
(terpri)
(quit)
