(require 'predicate-classes)
(in-package predicate-dispatch)

(defmethod print-object ((pred compound-predicate) str)
  (let ((prefix (typecase pred
		  (and-predicate "#<and ")
		  (or-predicate "#<or ")
		  (otherwise (concatenate "#<" (type-of pred) " ")))))
    (pprint-logical-block
     (str (subpreds-of pred))
     (princ prefix str)
     (pprint-indent :current 0 str)
     (do ((term (pprint-pop) (pprint-pop)))
	 (nil nil)
       (write term :stream str :pretty t)
       (pprint-exit-if-list-exhausted)
       (princ " " str)
       (pprint-newline :fill str))
     (princ ">" str))
    ;;(format str "~A~<~;~:W~_~;>~:>" prefix (subpreds-of pred))
    ))

(defmethod print-object ((pred not-predicate) str)
  (format str "#<not ~:W>" (base-of pred)))

(defmethod print-object ((pred test-predicate) str)
  ;(format str "#<test ~:W>" (test-of pred))
  (write (test-of pred) :stream str))

(defmethod print-object ((pred constant-predicate) str)
  (format str "#<const ~:W>" (value-of pred)))

(defmethod print-object ((pred projected-unary-predicate) str)
  (format str "#<proj ~A ~:W>" (index-of pred) (base-of pred)))

(defmethod print-object ((pred typecheck-predicate) str)
  (format str "#<type ~A>" (target-of pred)))

(defmethod print-object ((pred equality-predicate) str)
  (format str "#<eql ~A>" (target-of pred)))

(defmethod print-object ((pred extracting-unary-predicate) str)
  (format str "#<extr ~:W ~:W>" (accessors-of pred) (base-of pred)))

(defmethod print-object ((pq predicate-qualifier) str)
  (format str "#<pq ~A ~:W>" (auxv-count-of pq) (predicate-of pq)))

(provide 'pc-print)
