(require 'pd-package)
(in-package :predicate-dispatch)

;; supports => a la Scheme cond.
(defmacro xcond (&rest forms)
  (and forms
       (let ((form (car forms)))
	 (cond ((atom form) (error "Bad cond form ~A" form))
	       ((null (cdr form)) (let ((fresh-sym (gensym)))
				    `(let ((,fresh-sym ,(car form)))
				       (if ,fresh-sym
					   ,fresh-sym
					 (xcond ,@(cdr forms))))))
	       ((and (= (length form) 3) (eq (second form) '=>))
		(let ((fresh-sym (gensym)))
		  `(let ((,fresh-sym ,(car form)))
		     (if ,fresh-sym
			 (funcall ,(third form) ,fresh-sym)
		       (xcond ,@(cdr forms))))))
	       (t `(if ,(car form)
		       (progn ,@(cdr form))
		     (xcond ,@(cdr forms))))))))

(provide 'xcond)
